#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use htbuild;
use pseek;
use fmspm;

&get_setup;
fmspm::check_spamb("rgs_adet.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

if ($q->param('fct') eq "display_save2") {&display_save2; exit;}

$cpuserid = pseek::accesscheck($q->param('rgs_user'), $q->param('rgs_pass'));

if ($q->param('fct') eq "save") {&display_save;}

####

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&display_edit_details;}

################



sub display_save2
{
print "Content-type: text/html\n\n";

$edit_template = pseek::get_file_contents("$data_dir/rgs_saveacc.html");
$edit_template = pseek::ts_insert_template_includes($edit_template);
$edit_template = pseek::fill_vars($edit_template);

print $edit_template;
exit;
}




sub display_save
{

$ertext= "";

### CHECK FOR ERRORS

$rgtext = pseek::get_file_contents("$data_dir/regusers.txt"); 
@regtext = split (/\n/, $rgtext);

if ($q->param('rgspass') eq ""){ $ertext = $ertext .  $regtext[3] . "<BR>"; }
if ($q->param('rgsname') eq ""){ $ertext = $ertext .  $regtext[4] . "<BR>"; }
if ($q->param('rgsemail') eq ""){ $ertext = $ertext . $regtext[5] . "<BR>"; }

### CHECK EXTRA FIELDS

$fdata = pseek::get_file_contents("$data_dir/usrfields.dat"); 
@fdlines = split (/\n/, $fdata);

$no_val_field_text = $regtext[6];

$fcon = 1;
foreach $fitem (@fdlines)
	{
	($tmpd, $val_required) = split (/:::/, $fitem);
	
	if ($val_required eq "Y")
		{
		$fdname = "extra" . $fcon;
		if ($q->param($fdname) eq "")
			{
			$tmp_f_val = $no_val_field_text;
			$tmp_f_val =~ s/!!field!!/$tmpd/gi;
		   $ertext = $ertext . $tmp_f_val . "<BR>";
			}
		}
	
	$fcon++;
	}


if ($ertext ne ""){ print "Content-type: text/html\n\n"; &display_edit_details; exit;}

### SAVE CHANGES

$rgspass = $q->param('rgspass');
$rgsname  = $q->param('rgsname');
$rgsemail  = $q->param('rgsemail');
$extra1  = $q->param('extra1');
$extra2  = $q->param('extra2');
$extra3  = $q->param('extra3');
$extra4  = $q->param('extra4');
$extra5  = $q->param('extra5');
$extra6  = $q->param('extra6');
$extra7  = $q->param('extra7');
$extra8  = $q->param('extra8');
$extra9  = $q->param('extra9');
$extra10  = $q->param('extra10');


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "UPDATE lnkusers SET 	rgspass     = '$rgspass',
										rgsname     = '$rgsname',
										rgsemail    = '$rgsemail',
										rgs_extra1  = '$extra1',
										rgs_extra2  = '$extra2',
										rgs_extra3  = '$extra3',
										rgs_extra4  = '$extra4',
										rgs_extra5  = '$extra5',
										rgs_extra6  = '$extra6',
										rgs_extra7  = '$extra7',
										rgs_extra8  = '$extra8',
										rgs_extra9  = '$extra9',
										rgs_extra10 = '$extra10'
										
										WHERE userid = '$cpuserid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

$sth->finish;
$dbh->disconnect;  

### SET COOKIE FOR NEW PASSWORD

   $query = new CGI;
  
	$thecookie2 = $query->cookie(	-name=>'cppass',
				    						-value=>$rgspass,
				    						-expires=>'+24h',
				    						-path=>'/');
	
	print $query->header(-cookie=>[$thecookie2]); 

	print qq[<html>
			<head>
			<title>Powerseek</title>
			<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/rgs_adet.cgi?fct=display_save2">
			</head>
			<body>
			</body>
			</html>
		  ];
	exit;



}



sub display_edit_details
{

$edit_template = pseek::get_file_contents("$data_dir/rgs_editacc.html");


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT * FROM lnkusers WHERE userid = '$cpuserid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() )
	{

	if ($ertext ne "")
		{
		$edit_template =~ s/!!error_text!!/$ertext/gi;
	
		$rgspass = $q->param('rgspass');
		$rgsname  = $q->param('rgsname');
		$rgsemail  = $q->param('rgsemail');
		
		$extra1  = $q->param('extra1');
		$extra2  = $q->param('extra2');
		$extra3  = $q->param('extra3');
		$extra4  = $q->param('extra4');
		$extra5  = $q->param('extra5');
		$extra6  = $q->param('extra6');
		$extra7  = $q->param('extra7');
		$extra8  = $q->param('extra8');
		$extra9  = $q->param('extra9');
		$extra10  = $q->param('extra10');
		$mlist = $q->param('mlist');
		
		$edit_template =~ s/!!rgsuser!!/$row[1]/gi;
		
		$edit_template =~ s/!!rgspass!!/$rgspass/gi;
		
		$edit_template =~ s/!!rgsname!!/$rgsname/gi;
		$edit_template =~ s/!!rgsemail!!/$rgsemail/gi;
	
		$edit_template =~ s/!!extra1!!/$extra1/gi;
		$edit_template =~ s/!!extra2!!/$extra2/gi;
		$edit_template =~ s/!!extra3!!/$extra3/gi;
		$edit_template =~ s/!!extra4!!/$extra4/gi;
		$edit_template =~ s/!!extra5!!/$extra5/gi;
		$edit_template =~ s/!!extra6!!/$extra6/gi;
		$edit_template =~ s/!!extra7!!/$extra7/gi;
		$edit_template =~ s/!!extra8!!/$extra8/gi;
		$edit_template =~ s/!!extra9!!/$extra9/gi;
		$edit_template =~ s/!!extra10!!/$extra10/gi;
		
		if ($mlist eq "Y") { $edit_template =~ s/!!checked!!/checked/gi; }
		
		}
		else
		{
		
		$edit_template =~ s/!!error_text!!/$ertext/gi;
		
		$edit_template =~ s/!!rgsuser!!/$row[1]/gi;
		$edit_template =~ s/!!rgspass!!/$row[2]/gi;
		$edit_template =~ s/!!rgsname!!/$row[3]/gi;
		$edit_template =~ s/!!rgsemail!!/$row[4]/gi;
	
		$edit_template =~ s/!!extra1!!/$row[5]/gi;
		$edit_template =~ s/!!extra2!!/$row[6]/gi;
		$edit_template =~ s/!!extra3!!/$row[7]/gi;
		$edit_template =~ s/!!extra4!!/$row[8]/gi;
		$edit_template =~ s/!!extra5!!/$row[9]/gi;
		$edit_template =~ s/!!extra6!!/$row[10]/gi;
		$edit_template =~ s/!!extra7!!/$row[11]/gi;
		$edit_template =~ s/!!extra8!!/$row[12]/gi;
		$edit_template =~ s/!!extra9!!/$row[13]/gi;
		$edit_template =~ s/!!extra10!!/$row[14]/gi;
		
		$mlist = $row[16];
		if ($mlist eq "Y") { $edit_template =~ s/!!checked!!/checked/gi; }
		
		}
	}

$sth->finish;
$dbh->disconnect;  


$edit_template =~ s/!!save_details!!/$script_url\/rgs_adet\.cgi/gi;
$edit_template = pseek::ts_insert_template_includes($edit_template);
$edit_template = pseek::fill_vars($edit_template);

print $edit_template;

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

